<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2007 Tobias Klepp (tklepp@all4net.de)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Module 'ExtLangEditor' for the 'a4n_edit_locallang' extension.
 *
 * @author	Tobias Klepp <tklepp@all4net.de>
 */

// DEFAULT initialization of a module [BEGIN]
unset($MCONF);	
require('conf.php');
require($BACK_PATH.'init.php');
require($BACK_PATH.'template.php');
$LANG->includeLLFile('EXT:a4n_edit_locallang/mod1/locallang.xml');
require_once(PATH_t3lib.'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.

// DEFAULT initialization of a module [END]
class tx_a4neditlocallang_module1 extends t3lib_SCbase {
  var $pageinfo;
  
  function init() {
    global $AB, $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $_GET, $_POST, $CLIENT, $TYPO3_CONF_VARS;
    parent::init();
  }

  /**
  * Adds items to the ->MOD_MENU array. Used for the function menu selector.
  */
  function menuConfig() {
    global $LANG;
    $this->MOD_MENU = Array (
      'function' => Array (
        '1' => htmlspecialchars($LANG->getLL('globalFunction1')),
        '2' => htmlspecialchars($LANG->getLL('globalFunction2')),
        '3' => htmlspecialchars($LANG->getLL('globalFunction3')),
        '4' => htmlspecialchars($LANG->getLL('globalFunction4')),
      )
    );
    parent::menuConfig();
  }

  // If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
  /**
  * Main function of the module. Write the content to $this->content
  */
  function main() {
    global $AB, $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $_GET, $_POST, $CLIENT, $TYPO3_CONF_VARS;
      
    // Access check!
    // The page will show only if there is a valid page and if this page may be viewed by the user
    $this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
    $access = is_array($this->pageinfo) ? 1 : 0;
    
    if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))	{
	
      // Draw the header.
      $this->doc = t3lib_div::makeInstance('bigDoc');
      
      // include stylesheet
      $this->doc->inDocStyles = file_get_contents('format.css');
    
      $this->doc->backPath = $BACK_PATH;
      
      // JavaScript
      $this->doc->JScode = '<script language="javascript">script_ended = 0;function jumpToUrl(URL) {document.location = URL;}</script>';
      $this->doc->postCode = '<script language="javascript">script_ended = 1;if (top.theMenu) top.theMenu.recentuid = '.intval($this->id).';</script>';
      $headerSection = '';
      $this->content .= $this->doc->startPage($LANG->getLL('globalTitle'));
      $this->content .= $this->doc->header($LANG->getLL('globalTitle'));
      $this->content .= $this->doc->spacer(5);
      $this->content .= $this->doc->section('', $this->doc->funcMenu($headerSection, t3lib_BEfunc::getFuncMenu($this->id, 'SET[function]', $this->MOD_SETTINGS['function'], $this->MOD_MENU['function'])));
      $this->content .= $this->doc->divider(5);
      
      // Render content:
      $this->moduleContent();
      
      // ShortCut
      if($BE_USER->mayMakeShortcut()) {
        $this->content .= $this->doc->spacer(20).$this->doc->section('', $this->doc->makeShortcutIcon('id', implode(',', array_keys($this->MOD_MENU)), $this->MCONF['name']));
      }
      $this->content.=$this->doc->spacer(10);
    }
    else {
      
      // If no access or if ID == zero
      $this->doc = t3lib_div::makeInstance('bigDoc');
      $this->doc->backPath = $BACK_PATH;
      $this->content .= $this->doc->startPage($LANG->getLL('globalTitle'));
      $this->content .= $this->doc->header($LANG->getLL('globalTitle'));
      $this->content .= $this->doc->spacer(5);
      $this->content .= $this->doc->spacer(10);
    }
  }

  /**
  * Prints out the module HTML
  */
  function printContent() {
    global $SOBE;
    $this->content .= $this->doc->middle();
    $this->content .= $this->doc->endPage();
    echo($this->content);
  }
	
  /**
  * Generates the module content
  */
  function moduleContent() {
    $this->content .= '<div class="tx_a4neditlocallang_module1">';
    switch((string)$this->MOD_SETTINGS['function'])	{
      // function: edit language text
      case 1:
        if($this->CMD['save']) {
          $this->content .= $this->doc->section('', $this->editLocallang(), 0, 1);
        }
        $this->content .= $this->doc->section('', $this->selectExtension(), 0, 1);
        if($this->CMD['extension']) {
          $this->content .= $this->doc->section('', $this->selectFile(), 0, 1);
          if($this->CMD['file']) {
            $this->content .= $this->doc->section('', $this->selectLanguage(), 0, 1);
            if($this->CMD['language']) {
              $this->content .= $this->doc->section('', $this->editLocallangForm(), 0, 1);
            }
          }
        }
      break;
      // function: recover/delete backup
      case 2:
        if($this->CMD['delete']) {
          $this->content .= $this->doc->section('', $this->deleteBackup(), 0, 1);
        }
        if($this->CMD['recover']) {
          $this->content .= $this->doc->section('', $this->recoverBackup(), 0, 1);
        }
        $this->content .= $this->doc->section('', $this->selectExtension(), 0, 1);
        if($this->CMD['extension']) {
          $this->content .= $this->doc->section('', $this->selectFile(), 0, 1);
          if($this->CMD['file']) {
            $this->content .= $this->doc->section('', $this->selectBackup(), 0, 1);
            if($this->CMD['backup']) {
              $this->content .= $this->doc->section('', $this->recoverBackupForm(),0,1);
            }
          }
        }
      break;
      // function: edit language file
      case 3:
        if($this->CMD['save']) {
          $this->content .= $this->doc->section('', $this->editLangFile(), 0, 1);
        }
        $this->content .= $this->doc->section('', $this->selectExtension(), 0, 1);
        if($this->CMD['extension']) {
          $this->content .= $this->doc->section('', $this->selectFile(), 0, 1);
          if($this->CMD['file']) {
            $this->content .= $this->doc->section('', $this->editLangFileForm(), 0, 1);
          }
        }
      break;
      // function: settings
      case 4:
        if($this->CMD['save']) {
          $this->content .= $this->doc->section('', $this->editConf(), 0, 1);
        }
        $this->content .= $this->doc->section('', $this->editConfForm(), 0, 1);
      break;
      
    }
    $this->content .= '</div><div class="clear"></div>';
  }

  /**
   * show extension selection
   * languagePrefix: selExt
   *
   * @return $output
   */
  function selectExtension() {
    global $LANG, $MCONF;
    $output = '<form name="jump_extension" id="a4neditlocallang_jumpextension" method="post" action="index.php">
<p class="label"><label for="a4neditlocallang_extension">'.$LANG->getLL('globalExtension').'</label></p>
<p class="field"><select name="CMD[extension]" id="a4neditlocallang_extension" onchange="submit();">';
    if(!$this->CMD['extension']) {
      $selected = ' selected="selected"';
    }
    else {
      $selected = '';
    }
    // list local extension if enable
    if($MCONF['showLocalExtension']) {
      $output .= chr(10).'<option value=""'.$selected.'>&nbsp;</option>';
      $output .= chr(10).'<option value="" class="title">'.$LANG->getLL('globalLocalExtensions').'</option>';
      if(is_dir(PATH_site.$MCONF['localExtensionPath'])) {
        // read directories of local extensions
        $directories = array();
        $directories = t3lib_div::get_dirs(PATH_site.$MCONF['localExtensionPath']);
        sort($directories);
        foreach($directories as $directory) {
          // include ext_emconf.php for extension informations
          $extEmconfPath = PATH_site.$MCONF['localExtensionPath'].$directory.'/ext_emconf.php';
          if(file_exists($extEmconfPath)) {
            include($extEmconfPath);
            if($this->CMD['extension'] == PATH_site.$MCONF['localExtensionPath'].$directory.'/') {
              $selected = ' selected="selected"';
            }
            else {
              $selected = '';
            }
            $output .= chr(10).'<option value="'.PATH_site.$MCONF['localExtensionPath'].$directory.'/"'.$selected.'>';
            if($MCONF['showExtensionKey']) {
              $output .= $directory;
            }
            if($MCONF['showExtensionTitle'] && $MCONF['showExtensionKey']) {
              $output .= ' ('.$EM_CONF['']['title'].')';
            }
            if($MCONF['showExtensionTitle'] && !$MCONF['showExtensionKey']) {
              $output .= $EM_CONF['']['title'];
            }
            $output .= '</option>';
          }
        }
      }
      else {
        $output .= chr(10).'<option value="">'.$LANG->getLL('selExtWrongLocalExtensionPath').'</option>';
      }
    }
    // list system extension if enable
    if($MCONF['showSystemExtension']) {
      $output .= chr(10).'<option value="">&nbsp;</option>';
      $output .= chr(10).'<option value="" class="title">'.$LANG->getLL('globalSystemExtensions').'</option>';
      if(is_dir(PATH_site.$MCONF['systemExtensionPath'])) {
        // read directories of system extensions
        $directories = array();
        $directories = t3lib_div::get_dirs(PATH_site.$MCONF['systemExtensionPath']);
        sort($directories);
        foreach($directories as $directory) {
          // include ext_emconf.php for extension informations
          $extEmconfPath = PATH_site.$MCONF['systemExtensionPath'].$directory.'/ext_emconf.php';
          if(file_exists($extEmconfPath)) {
            include($extEmconfPath);
            if($this->CMD['extension'] == PATH_site.$MCONF['systemExtensionPath'].$directory.'/') {
              $selected = ' selected="selected"';
            }
            else {
              $selected = '';
            }
            $output .= chr(10).'<option value="'.PATH_site.$MCONF['systemExtensionPath'].$directory.'/"'.$selected.'>';
            if($MCONF['showExtensionKey']) {
              $output .= $directory;
            }
            if($MCONF['showExtensionTitle'] && $MCONF['showExtensionKey']) {
              $output .= ' ('.$EM_CONF['']['title'].')';
            }
            if($MCONF['showExtensionTitle'] && !$MCONF['showExtensionKey']) {
              $output .= $EM_CONF['']['title'];
            }
            $output .= '</option>';
          }
        }
      }
      else {
        $output .= chr(10).'<option value="">'.$LANG->getLL('selExtWrongSystemExtensionPath').'</option>';
      }
    }
    $output .= chr(10).'</select></p>
</form>';
    return $output;
  }
	
  /**
   * show file selection
   * languagePrefix: selFil
   *
   * @return $output
   */
  function selectFile() {
    global $LANG, $MCONF;
    $output = '<form name="jump_file" id="a4neditlocallang_jumpfile" method="post" action="index.php">
<p class="label"><label for="a4neditlocallang_file">'.$LANG->getLL('globalFile').'</label></p>
<p class="field"><select name="CMD[file]" id="a4neditlocallang_file" onchange="submit();">';
    if(!$this->CMD['file']) {
      $selected = ' selected="selected"';
    }
    else {
      $selected = '';
    }
    $output .= chr(10).'<option value=""'.$selected.'>&nbsp;</option>';
    // list language files from extension directory
    $files = t3lib_div::getAllFilesAndFoldersInPath(array(), $this->CMD['extension'], '', 1);
    $extensionPathLength = strlen($this->CMD['extension']);
    $foundFile = 0;
    foreach($files as $file) {
      if(strpos(basename($file), 'locallang') !== false) {
        $pathInfo = pathinfo($file);
        if($pathInfo['extension'] == 'php' || $pathInfo['extension'] == 'xml') {
          if($this->CMD['file'] == $file) {
            $selected = ' selected="selected"';
          }
          else {
            $selected = '';
          }
          $foundFile = 1;
          $output .= chr(10).'<option value="'.$file.'"'.$selected.'>'.substr($file, $extensionPathLength, strlen($file)).'</option>';
        }
      }
    }
    if(!$foundFile) {
      $output .= chr(10).'<option value="">'.$LANG->getLL('selFilNoFile').'</option>';
    }
    $output .= chr(10).'</select></p>
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
</form>';
    return $output;
  }

  /**
   * show language selection
   * languagePrefix: selLan
   *
   * @return $output
   */
  function selectLanguage() {
    // TODO: aktivierbar in den Einstellungen machen, dass die verfügbaren Sprachen auch aus den Übersetzungsdateien eingelesen werden (nur für UTF-8-Systeme)
    global $LANG, $MCONF;
    // include language file to read available languages
    $pathInfo = pathinfo($this->CMD['file']);
    if($pathInfo['extension'] == 'php') {
      include($this->CMD['file']);
    }
    else {
      $LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['file']));
      $LOCAL_LANG = $LOCAL_LANG['data'];
      #$languages = explode('|', TYPO3_languages);
      #$LOCAL_LANG = array();
      #foreach($languages as $language) {
      #  $LOCAL_LANG = array_merge($LOCAL_LANG, t3lib_div::readLLXMLfile($this->CMD['file'], $language));
      #}
    }
    // if a default language is set and no language is selected, set the selected language with default language
    if($MCONF['defaultLanguage'] && !$this->CMD['language']) {
      $this->CMD['language'] = $MCONF['defaultLanguage'];
    }
    // clear selected language if default language don't exist and no language is selected
    if(!$LOCAL_LANG[$MCONF['defaultLanguage']] && !$this->CMD['language']) {
      $this->CMD['language'] = '';
    }
    $languages = array_keys($LOCAL_LANG);
    $output = '<form name="jump_language" id="a4neditlocallang_jumplanguage" method="post" action="index.php">
<p class="label"><label for="a4neditlocallang_language">'.$LANG->getLL('globalLanguage').'</label></p>
<p><select name="CMD[language]" id="a4neditlocallang_language" onchange="submit();">';
    if(!$this->CMD['language']) {
      $selected = ' selected="selected"';
    }
    else {
      $selected = '';
    }
    $output .= chr(10).'<option value=""'.$selected.'>&nbsp;</option>';
    // list languages with one entrie at least
    for($i = 0; $i < count($languages); $i++) {
      if($this->CMD['language'] == $languages[$i]) {
        $selected = ' selected="selected"';
      }
      else {
        $selected = '';
      }
      if(count($LOCAL_LANG[$languages[$i]]) > 0) {
        $output .= chr(10).'<option value="'.$languages[$i].'"'.$selected.'>'.$languages[$i].'</option>';
      }
    }
    $output .= chr(10).'</select></p>
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
<input type="hidden" name="CMD[file]" value="'.$this->CMD['file'].'" />
</form>';
    return $output;
  }

 /**
  * show locallang edit form
  * languagePrefix: updLan
  *
  * @return $output
  */
  function editLocallangForm() {
    global $LANG, $MCONF;
    $pathInfo = pathinfo($this->CMD['file']);
    // read language file
    if($pathInfo['extension'] == 'php') {
      include($this->CMD['file']);
    }
    else {
      $LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['file']));
      $LOCAL_LANG = $LOCAL_LANG['data'];
      $LANG->csConvObj->convArray(&$LOCAL_LANG, 'utf-8', $this->doc->charset);
    }
    $languages = array_keys($LOCAL_LANG);
    foreach($languages as $language) {
      if($language == $this->CMD['language']) {
        $languageTexts = array_keys($LOCAL_LANG[$this->CMD['language']]);
      }
    }
    $output = '<form name="languagetext" id="a4neditlocallang_languagetext" method="post" action="index.php">';
    // build edit form
    for($i = 0; $i < count($LOCAL_LANG[$this->CMD['language']]); $i++) {
      $output .= chr(10).'<p class="label"><label for="a4neditlocallang_data'.$i.'">'.$languageTexts[$i].'</label></p>';
      if($MCONF['charencodingsRead'] != $MCONF['charencodingsShow']) {
        $content = $LANG->csConvObj->conv($LOCAL_LANG[$this->CMD['language']][$languageTexts[$i]], $MCONF['charencodingsRead'], $MCONF['charencodingsShow']);
      }
      else {
        $content = $LOCAL_LANG[$this->CMD['language']][$languageTexts[$i]];
      }
      if(strlen($content) > $MCONF['textLengthFormChange']) {
        $rows = ceil(strlen($content) / $MCONF['textLengthFormChange']);
        $output .= chr(10).'<p class="field"><textarea name="CMD[data][]" id="a4neditlocallang_data'.$i.'" rows="'.$rows.'" wrap="virtual">'.htmlspecialchars($content).'</textarea></p>';
      }
      else {
        $output .= chr(10).'<p class="field"><input name="CMD[data][]" type="text" id="a4neditlocallang_data'.$i.'" value="'.htmlspecialchars($content).'" /></p>';
      }
      if($MCONF['translationDraft']) {
        $output .= chr(10).'<p class="orgtext">'.$LOCAL_LANG[$MCONF['translationDraft']][$languageTexts[$i]].'</p>';
      }
    }
    $output .= chr(10).'<p class="send"><input class="autowidth" name="CMD[save]" type="submit" value="'.$LANG->getLL('globalSave').'" />
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
<input type="hidden" name="CMD[file]" value="'.$this->CMD['file'].'" />
<input type="hidden" name="CMD[language]" value="'.$this->CMD['language'].'" /></p>
</form>';
    return $output;
  }
	
 /**
  * save locallang edit form
  * languagePrefix: savLan
  *
  * @return $output
  */
  function editLocallang() {
    global $LANG, $MCONF;
    $pathInfo = pathinfo($this->CMD['file']);
    // read language file
    if($pathInfo['extension'] == 'php') {
      include($this->CMD['file']);
    }
    else {
      $XML_LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['file']));
      $LOCAL_LANG = $XML_LOCAL_LANG['data'];
    }
    $languages = array_keys($LOCAL_LANG);
    // find extension key
    $extensionKey = strstr($this->CMD['extension'], $MCONF['systemExtensionPath']);
    if($extensionKey) {
      $extensionKey = substr($extensionKey, strlen($MCONF['systemExtensionPath']));
    }
    if(!$extensionKey) {
      $extensionKey = strstr($this->CMD['extension'], $MCONF['localExtensionPath']);
      $extensionKey = substr($extensionKey, strlen($MCONF['localExtensionPath']));
    }
    if($pathInfo['extension'] == 'php') {
      // build php file content
      $data = '<?php
/*
 * Language labels for plugin "';
$data .= $extensionKey;
$data .= '"
 *
 * This file is detected by the translation tool.
 * Modified by "extension language editor" at ';
$data .= date("Y-m-d H:i:s");
$data .= '
 */

$LOCAL_LANG = Array ('.chr(10);
    for($i = 0; $i < count($languages); $i++) {
      $data .= "\t'".$languages[$i]."' => Array (".chr(10);
      $text_array = array_keys($LOCAL_LANG[$languages[$i]]);
      for($j = 0; $j < count($text_array); $j++) {
        if($languages[$i] == $this->CMD['language']) {
          $filecontent = str_replace("\'", "'", $this->CMD['data'][$j]);
          $filecontent = str_replace('\"', '"', $filecontent);
          $filecontent = str_replace("'", "\'", $filecontent);
          if($MCONF['charencodingsShow'] != $MCONF['charencodingsWrite']) {
            $filecontent = $LANG->csConvObj->conv($filecontent, $MCONF['charencodingsShow'], $MCONF['charencodingsWrite']);
          }
          $data .= "\t\t'".$text_array[$j]."' => '".$filecontent."',".chr(10);
        }
        else {
          $filecontent = str_replace("\'", "'", $LOCAL_LANG[$languages[$i]][$text_array[$j]]);
          $filecontent = str_replace("\\'", "\'", $filecontent);
          $filecontent = str_replace('\"', '"', $filecontent);
          $filecontent = str_replace("'", "\'", $filecontent);
          $data .= "\t\t'".$text_array[$j]."' => '".$filecontent."',".chr(10);
        }
      }
      $data .= "\t),".chr(10);
    }
    $data .= ');
?>';
    }
    else {
      // build xml file content
      $data = $this->CMD['data'];
      $charset = $LANG->csConvObj->charSetArray[$this->CMD['language']];
      if(!$charset) {
        $charset = 'iso-8859-1';
      }
      $charset = $LANG->csConvObj->parse_charset($charset);
      for($i = 0; $i < count($languages); $i++) {
        $text_array = array_keys($LOCAL_LANG[$languages[$i]]);
        for($j = 0; $j < count($text_array); $j++) {
          if($languages[$i] == $this->CMD['language']) {
            $LOCAL_LANG[$languages[$i]][$text_array[$j]] = $LANG->csConvObj->utf8_encode($data[$j], $charset);
          }
        }
      }
      $XML_LOCAL_LANG['data'] = $LOCAL_LANG;
      $options = array(
        'parentTagMap' => array(
          'data' => 'languageKey',
          'orig_hash' => 'languageKey',
          'orig_text' => 'languageKey',
          'labelContext' => 'label',
          'languageKey' => 'label'
        )
      );
      $data = '<?xml version="1.0" encoding="utf-8" standalone="yes" ?>'.chr(10);
      $data .= t3lib_div::array2xml($XML_LOCAL_LANG, '', 0, 'T3locallang', 4, $options);
    }
    if($MCONF['backup']) {
      // make backup
      if($this->makeBackup($this->CMD['file'])) {
        $backup = ' '.$LANG->getLL('globalBackupOk');
      }
      else {
        $backup = ' '.$LANG->getLL('globalBackupKo');
      }
    }
    if($this->writeFile($this->CMD['file'], $data)) {
      $output = '<p class="ok">'.$LANG->getLL('globalSaveOk').$backup.'</p>';
    }
    else {
      $output = '<p class="ko">'.$LANG->getLL('globalSaveKo').'</p>';
    }
    return $output;
  }

 /**
  * show backup selection
  * languagePrefix: selBac
  *
  * @return $output
  */
  function selectBackup() {
    global $LANG, $MCONF;
    $files = t3lib_div::getFilesInDir(dirname($this->CMD['file']), '', 0, 'mtime');
    foreach($files as $file) {
      // build backup selection menu
      if(stristr($file, basename($this->CMD['file'],'.php').'.php.') || stristr($file, basename($this->CMD['file'],'.xml').'.xml.')) {
        if($this->CMD['backup'] == dirname($this->CMD['file']).'/'.$file) {
          $selected = ' selected="selected"';
        }
        else {
          $selected = '';
        }
        // format date
        list($filename, $type, $datedata) = split('\.', $file);
        list($date, $time) = split('_', $datedata);
        list($year, $month, $day) = split('-', $date);
        $time = strtr($time, '-', ':');
        $options .= chr(10).'<option value="'.dirname($this->CMD['file']).'/'.$file.'"'.$selected.'>'.$day.'.'.$month.'.'.$year.' '.$time.'</option>';
      }
    }
    if($options) {
      $output = '<form name="jump_backup" id="a4neditlocallang_jumpbackup" method="post" action="index.php">
<p class="label"><label for="a4neditlocallang_backup">'.$LANG->getLL('globalBackup').'</label></p>
<p><select name="CMD[backup]" id="a4neditlocallang_backup" onchange="submit();">';
      if(!$this->CMD['backup']) {
        $selected = ' selected="selected"';
      }
      else {
        $selected = '';
      }
      $output .= '<option value=""'.$selected.'>&nbsp;</option>';
      $output .= $options;
      $output .= chr(10).'</select></p>
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
<input type="hidden" name="CMD[file]" value="'.$this->CMD['file'].'" />
</form>';
    }
    else {
      $output .= '<div class="clear"></div><p class="empty">'.$LANG->getLL('selBacNoBackup').'</p>';
    }
    return $output;
  }

 /**
  * show recover backup form
  * languagePrefix: recBac
  *
  * @return $output
  */
  function recoverBackupForm() {
    // TODO: Textdifferenz zwischen aktueller Sprachdatei und Backup-Sprachdatei anzeigen
    global $LANG, $MCONF;
    list($filename, $type, $datedata) = split('\.', $this->CMD['backup']);
    // read backup file
    if($type == 'php') {
      include($this->CMD['backup']);

    }
    else {
      $XML_LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['backup']));
      $LOCAL_LANG = $XML_LOCAL_LANG['data'];
      $LANG->csConvObj->convArray(&$LOCAL_LANG, 'utf-8', $this->doc->charset);
    }
    $languages = array_keys($LOCAL_LANG);
    // build preview table
    if(count($languages) > 0) {
      $output = '<form name="languagetext" id="a4neditlocallang_languagetext" method="post" action="index.php">
<table border="0" cellspacing="0" cellpadding="0">';
    }
    for($i = 0; $i < count($languages); $i++) {
      $output .= chr(10).'<tr>
<th colspan="2">'.$languages[$i].'</th>
</tr>';
      $texts = array_keys($LOCAL_LANG[$languages[$i]]);
      for($j = 0; $j < count($texts); $j++) {
        $output .= chr(10).'<tr>
<td class="key">'.$texts[$j].':</td>';
        $output .= chr(10).'<td>'.$LOCAL_LANG[$languages[$i]][$texts[$j]].'</td>
</tr>';
      }
    }
    if(count($languages) == 0) {
      $output .= '<p class="empty">'.$LANG->getLL('recBacNoTexts').'</p>';
    }
    $output .= chr(10).'</table>
<p class="send"><input class="autowidth" name="CMD[recover]" type="submit" value="'.$LANG->getLL('recBacRecover').'" />
<input class="autowidth" name="CMD[delete]" type="submit" value="'.$LANG->getLL('recBacDelete').'" />
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
<input type="hidden" name="CMD[file]" value="'.$this->CMD['file'].'" />
<input type="hidden" name="CMD[backup]" value="'.$this->CMD['backup'].'" /></p>
</form>';
    return $output;
  }
	
 /**
  * save recover backup form
  * languagePrefix: savBac
  *
  * @return $output
  */
  function recoverBackup() {
    global $LANG, $MCONF;
    if($MCONF['backup']) {
      // make backup
      if(copy($this->CMD['file'], $this->CMD['file'].'.'.date("Y-m-d_H-i-s"))) {
        $output = '<p class="ok">'.$LANG->getLL('globalBackupOk');
        // copy backup to language file
        if(copy($this->CMD['backup'], $this->CMD['file'])) {
          $output .= ' '.$LANG->getLL('savBacOk').'</p>';
        }
        else {
          $output .= ' '.$LANG->getLL('savBacKo').'</p>';
        }
      }
      else {
        $output = '<p class="ko">'.$LANG->getLL('globalBackupKo');
      }
    }
    return $output;
  }
	
 /**
  * save delete backup form
  * languagePrefix: delBac
  *
  * @return $output
  */
  function deleteBackup() {
    global $LANG, $MCONF;
    // delete backup
    if(unlink($this->CMD['backup'])) {
      $output .= '<p class="ok">'.$LANG->getLL('delBacOk').'</p>';
    }
    else {
      $output .= '<p class="ko">'.$LANG->getLL('delBacKo').'</p>';
    }
    $this->CMD['backup'] = '';
    return $output;
  }

 /**
  * show edit language file form
  * languagePrefix: updFil
  *
  * @return $output
  */
  function editLangFileForm() {
    global $LANG, $MCONF;
    $pathInfo = pathinfo($this->CMD['file']);
    // read language file
    if($pathInfo['extension'] == 'php') {
      include($this->CMD['file']);
    }
    else {
      $XML_LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['file']));
      $LOCAL_LANG = $XML_LOCAL_LANG['data'];
    }
    // build language file form
    $output = '<div class="clear"></div><br /><p>'.$LANG->getLL('ediFilDescription').'</p>
<form name="repair_language" id="a4neditlocallang_repairlanguage" method="post" action="index.php">
<table class="repair" border="0" cellspacing="0" cellpadding="0">
<tr>
<th>'.$LANG->getLL('ediFilLanguage').'</th>
<th>'.$LANG->getLL('ediFilEntries').'</th>
<th class="status">'.$LANG->getLL('ediFilStatus').'</th>
<th class="status">'.$LANG->getLL('ediFilReference').'</th>
<th>'.$LANG->getLL('ediFilAllocation').'</th>
<th>'.$LANG->getLL('ediFilClear').'</th>
<th>'.$LANG->getLL('ediFilDelete').'</th>
<th>'.$LANG->getLL('ediFilNothing').'</th>
</tr>';
    $languages = array_keys($LOCAL_LANG);
    $counter = 0;
    for($i = 0; $i < count($languages); $i++) {
      if(count($LOCAL_LANG[$languages[$i]]) > $counter) {
        $counter = count($LOCAL_LANG[$languages[$i]]);
      }
    }
    for($i = 0; $i < count($languages); $i++) {
      $output .= chr(10).'<tr>';
      $output .= chr(10).'<td>'.$languages[$i].'</td>';
      $output .= chr(10).'<td>'.count($LOCAL_LANG[$languages[$i]]).'</td>';
      if(count($LOCAL_LANG[$languages[$i]]) == 0) {
        $output .= chr(10).'<td class="status">'.$LANG->getLL('ediFilStatus2').'</td>';
      }
      else if(count($LOCAL_LANG[$languages[$i]]) != $counter) {
        $error = $counter - count($LOCAL_LANG[$languages[$i]]);
        $output .= chr(10).'<td class="keysko">'.$error.' '.$LANG->getLL('ediFilStatus1').'</td>';
      }
      else {
        $output .= chr(10).'<td class="keysok">'.$LANG->getLL('ediFilStatus0').'</td>';
      }
      $output .= chr(10).'<td class="status"><input class="autowidth" name="CMD['.$languages[$i].']" type="radio" id="a4neditlocallang_'.$languages[$i].'" value="ref" /></td>
<td><input class="autowidth" name="CMD['.$languages[$i].']" type="radio" id="a4neditlocallang_'.$languages[$i].'" value="target" /></td>
<td><input class="autowidth" name="CMD['.$languages[$i].']" type="radio" id="a4neditlocallang_'.$languages[$i].'" value="clear" /></td>
<td><input class="autowidth" name="CMD['.$languages[$i].']" type="radio" id="a4neditlocallang_'.$languages[$i].'" value="del" /></td>
<td><input class="autowidth" name="CMD['.$languages[$i].']" type="radio" id="a4neditlocallang_'.$languages[$i].'" value="no" checked="checked" /></td>
</tr>';
    }
    $output .= chr(10).'</table>
<p class="label"><label for="a4neditlocallang_newlanguage">'.$LANG->getLL('ediFilNewLanguage').'</label></p>
<p class="field"><input name="CMD[newlanguage]" type="text" id="a4neditlocallang_newlanguage" value="" /></p>
<p class="send"><input class="autowidth" name="CMD[save]" type="submit" value="'.$LANG->getLL('globalSave').'" />
<input type="hidden" name="CMD[extension]" value="'.$this->CMD['extension'].'" />
<input type="hidden" name="CMD[file]" value="'.$this->CMD['file'].'" /></p>
</form>';
    return $output;
  }

 /**
  * save edit language file form
  * languagePrefix: savFil
  *
  * @return $output
  */
  function editLangFile() {
    global $LANG, $MCONF;
    $pathInfo = pathinfo($this->CMD['file']);
    // read language file
    if($pathInfo['extension'] == 'php') {
      include($this->CMD['file']);
    }
    else {
      $XML_LOCAL_LANG = t3lib_div::xml2array(file_get_contents($this->CMD['file']));
      $LOCAL_LANG = $XML_LOCAL_LANG['data'];
    }
    $languages = array_keys($LOCAL_LANG);
    // find extension key
    $extensionKey = strstr($this->CMD['extension'], $MCONF['systemExtensionPath']);
    if($extensionKey) {
      $extensionKey = substr($extensionKey, strlen($MCONF['systemExtensionPath']));
    }
    if(!$extensionKey) {
      $extensionKey = strstr($this->CMD['extension'], $MCONF['localExtensionPath']);
      $extensionKey = substr($extensionKey, strlen($MCONF['localExtensionPath']));
    }
    if($pathInfo['extension'] == 'php') {
      // build php file content
      $data = '<?php
/*
 * Language labels for plugin "';
$data .= $extensionKey;
$data .= '"
 *
 * This file is detected by the translation tool.
 * Modified by "extension language editor" at ';
$data .= date("Y-m-d H:i:s");
$data .= '
 */

$LOCAL_LANG = Array ('."\n";
      // search for reference in post data
      $key = array_search('ref', $this->CMD);
      if($key) {
        $targetLanguage = $key;
      }
      for($i = 0; $i < count($languages); $i++) {
        if($this->CMD[$languages[$i]] != 'del') {
          $data .= "\t'".$languages[$i]."' => Array (\n";
          if($this->CMD[$languages[$i]] != 'clear') {
            // target
            if(($this->CMD[$languages[$i]] == 'target') && ($key)) {
              $texts = array_keys($LOCAL_LANG[$targetLanguage]);
            }
            else {
              $texts = array_keys($LOCAL_LANG[$languages[$i]]);
            }
            for($j = 0; $j < count($texts); $j++) {
              $content = str_replace("'", "\'", $LOCAL_LANG[$languages[$i]][$texts[$j]]);
              $content = str_replace('\"', '"', $content);
              $content = str_replace("\\'", "\'", $content);
              $content = 
              $data .= "\t\t'".$texts[$j]."' => '".$content."',\n";
            }
          }
          $data .= "\t),\n";
        }
      }
      if($this->CMD['newlanguage']) {
        $texts = array_keys($LOCAL_LANG['default']);
        $data .= "\t'".$this->CMD['newlanguage']."' => Array (\n";
        for($j = 0; $j < count($texts); $j++) {
          $data .= "\t\t'".$texts[$j]."' => '',\n";
        }
        $data .= "\t),\n";
      }
      $data .= ');
?>';
    }
    else {
      // build xml file content
      // search for reference in post data
      $key = array_search('ref', $this->CMD);
      if($key) {
        $targetLanguage = $key;
      }
      // create an empty array with the keys from default language
      foreach($LOCAL_LANG['default'] as $key => $value) {
        $emptyArray[$key] = '';
      }
      for($i = 0; $i < count($languages); $i++) {
        // delete
        if($this->CMD[$languages[$i]] == 'del') {
          array_splice(&$LOCAL_LANG, $i, 1);
        }
        // clear
        if($this->CMD[$languages[$i]] == 'clear') {
          $LOCAL_LANG[$languages[$i]] = $emptyArray;
        }
        // target
        if($this->CMD[$languages[$i]] == 'target' && $key) {
          $LOCAL_LANG[$languages[$i]] = $LOCAL_LANG[$targetLanguage];
        }
      }
      // add a new language array with the keys from default
      if($this->CMD['newlanguage']) {
        $LOCAL_LANG[$this->CMD['newlanguage']] = $emptyArray;
      }
      $XML_LOCAL_LANG['data'] = $LOCAL_LANG;
      $options = array(
        'parentTagMap' => array(
          'data' => 'languageKey',
          'orig_hash' => 'languageKey',
          'orig_text' => 'languageKey',
          'labelContext' => 'label',
          'languageKey' => 'label'
        )
      );
      $data = '<?xml version="1.0" encoding="utf-8" standalone="yes" ?>'.chr(10);
      $data .= t3lib_div::array2xml($XML_LOCAL_LANG, '', 0, 'T3locallang', 4, $options);
    }
    if($MCONF['backup']) {
      // make backup
      if(copy($this->CMD['file'], $this->CMD['file'].'.'.date("Y-m-d_H-i-s"))) {
        $backup = ' '.$LANG->getLL('globalBackupOk');
      }
      else {
        $backup = ' '.$LANG->getLL('globalBackupKo');
      }
    }
    // write file
    if($this->writeFile($this->CMD['file'], $data)) {
      $output = '<p class="ok">'.$LANG->getLL('globalSaveOk').$backup.'</p>';
    }
    else {
      $output = '<p class="ko">'.$LANG->getLL('globalSaveKo').'</p>';
    }
    return $output;
  }

 /**
  * show edit configuration file form
  * languagePrefix: updCon
  *
  * @return $output
  */
  function editConfForm() {
    global $LANG, $MCONF;
    // build configuration form
    $output = '<form name="settings" id="a4neditlocallang_settings" method="post" action="index.php">
<h1>'.$LANG->getLL('ediConPathTitle').'</h1>
<p>'.$LANG->getLL('ediConPathDescription').'</p>
<p class="label"><label for="a4neditlocallang_localextensionpath">'.$LANG->getLL('globalLocalExtensions').'</label></p>
<p class="field"><input name="CMD[localExtensionPath]" type="text" id="a4neditlocallang_localextensionpath" value="'.htmlspecialchars($MCONF['localExtensionPath']).'" /></p>
<p class="label"><label for="a4neditlocallang_systemextensionpath">'.$LANG->getLL('globalSystemExtensions').'</label></p>
<p class="field"><input name="CMD[systemExtensionPath]" type="text" id="a4neditlocallang_systemextensionpath" value="'.htmlspecialchars($MCONF['systemExtensionPath']).'" /></p>
<h1>'.$LANG->getLL('ediConLanguageTitle').'</h1>
<p>'.$LANG->getLL('ediConLanguageDescription').'</p>
<p class="label"><label for="a4neditlocallang_defaultlanguage">'.$LANG->getLL('ediConDefaultLanguage').'</label></p>
<p class="field"><input name="CMD[defaultLanguage]" type="text" id="a4neditlocallang_defaultlanguage" value="'.htmlspecialchars($MCONF['defaultLanguage']).'" /></p>
<p class="label"><label for="a4neditlocallang_translationdraft">'.$LANG->getLL('ediConTranslationDraft').'</label></p>
<p class="field"><input name="CMD[translationDraft]" type="text" id="a4neditlocallang_translationdraft" value="'.htmlspecialchars($MCONF['translationDraft']).'" /></p>
<h1>'.$LANG->getLL('ediConCharencodingTitle').'</h1>
<p>'.$LANG->getLL('ediConCharencodingDescription').'</p>
<p class="label"><label for="a4neditlocallang_charencodings">'.$LANG->getLL('ediConCharencodings').'</label></p>
<p class="field"><input name="CMD[charencodings]" type="text" id="a4neditlocallang_charencodings" value="'.htmlspecialchars($MCONF['charencodings']).'" /></p>
<p class="label"><label for="a4neditlocallang_charencodingread">'.$LANG->getLL('ediConCharencodingRead').'</label></p>
<p class="field"><select name="CMD[charencodingsRead]" id="a4neditlocallang_charencodingread">
<option value=""></option>';
	  $charencodings = explode(',', $MCONF['charencodings']);
	  for($i = 0; $i < count($charencodings); $i++) {
	    if($MCONF['charencodingsRead'] == $charencodings[$i]) {
	      $selected = ' selected="selected"';
	    }
	    else {
	      $selected = '';
	    }
	    $output .= chr(10).'<option value="'.$charencodings[$i].'"'.$selected.'>'.$charencodings[$i].'</option>';
	  }
	  $output .= chr(10).'</select></p>
<p class="label"><label for="a4neditlocallang_charencodingwrite">'.$LANG->getLL('ediConCharencodingWrite').'</label></p>
<p class="field"><select name="CMD[charencodingsWrite]" id="a4neditlocallang_charencodingwrite">
<option value=""></option>';
	  for($i = 0; $i < count($charencodings); $i++) {
	    if($MCONF['charencodingsWrite'] == $charencodings[$i]) {
	      $selected = ' selected="selected"';
	    }
	    else {
	      $selected = '';
	    }
	    $output .= chr(10).'<option value="'.$charencodings[$i].'"'.$selected.'>'.$charencodings[$i].'</option>';
	  }
	  $output .= chr(10).'</select></p>
<p class="label"><label for="a4neditlocallang_charencodingshow">'.$LANG->getLL('ediConCharencodingShow').'</label></p>
<p class="field"><select name="CMD[charencodingsShow]" id="a4neditlocallang_charencodingshow">
<option value=""></option>';
	  for($i = 0; $i < count($charencodings); $i++) {
	    if($MCONF['charencodingsShow'] == $charencodings[$i]) {
	      $selected = ' selected="selected"';
	    }
	    else {
	      $selected = '';
	    }
	    $output .= chr(10).'<option value="'.$charencodings[$i].'"'.$selected.'>'.$charencodings[$i].'</option>';
	  }
	  $output .= chr(10).'</select></p>';
	  if($MCONF['showLocalExtension']) {
	    $checkedShowLocalExtension = ' checked="checked"';
	  }
	  else {
	    $checkedShowLocalExtension = '';
	  }
	  if($MCONF['showSystemExtension']) {
	    $checkedShowSystemExtension = ' checked="checked"';
	  }
	  else {
	    $checkedShowSystemExtension = '';
	  }
	  if($MCONF['showExtensionKey']) {
	    $checkedShowExtensionKey = ' checked="checked"';
	  }
	  else {
	    $checkedShowExtensionKey = '';
	  }
	  if($MCONF['showExtensionTitle']) {
	    $checkedShowExtensionTitle = ' checked="checked"';
	  }
	  else {
	    $checkedShowExtensionTitle = '';
	  }
	  $output .= chr(10).'<h1>'.$LANG->getLL('ediConShowTitle').'</h1>
<p>'.$LANG->getLL('ediConShowDescription').'</p>
<p class="label"><label for="a4neditlocallang_showlocalextension">'.$LANG->getLL('ediConShowLocalExtension').'</label></p>
<p class="field"><input class="autowidth" name="CMD[showLocalExtension]" type="checkbox" id="a4neditlocallang_showlocalextension" value="1"'.$checkedShowLocalExtension.' /></p>
<p class="label"><label for="a4neditlocallang_showsystemextension">'.$LANG->getLL('ediConShowSystemExtension').'</label></p>
<p class="field"><input class="autowidth" name="CMD[showSystemExtension]" type="checkbox" id="a4neditlocallang_showsystemextension" value="1"'.$checkedShowSystemExtension.' /></p>
<p class="label"><label for="a4neditlocallang_showextensionkey">'.$LANG->getLL('ediConShowExtensionKey').'</label></p>
<p class="field"><input class="autowidth" name="CMD[showExtensionKey]" type="checkbox" id="a4neditlocallang_showextensionkey" value="1"'.$checkedShowExtensionKey.' /></p>
<p class="label"><label for="a4neditlocallang_showextensiontitle">'.$LANG->getLL('ediConShowExtensionTitle').'</label></p>
<p class="field"><input class="autowidth" name="CMD[showExtensionTitle]" type="checkbox" id="a4neditlocallang_showextensiontitle" value="1"'.$checkedShowExtensionTitle.' /></p>
<p class="label"><label for="a4neditlocallang_textlengthformchange">'.$LANG->getLL('ediConTextLengthFormChange').'</label></p>
<p class="field"><input name="CMD[textLengthFormChange]" type="text" id="a4neditlocallang_textlengthformchange" value="'.htmlspecialchars($MCONF['textLengthFormChange']).'" /></p>
';
	  if($MCONF['backup']) {
	    $checkedMakeBackup = ' checked="checked"';
	  }
	  else {
	    $checkedMakeBackup = '';
	  }
	  $output .= '<h1>'.$LANG->getLL('ediConBackupTitle').'</h1>
<p>'.$LANG->getLL('ediConBackupDescription').'</p>
<p class="label"><label for="a4neditlocallang_backup">'.$LANG->getLL('ediConMakeBackup').'</label></p>
<p class="field"><input class="autowidth" name="CMD[backup]" type="checkbox" id="a4neditlocallang_backup" value="1"'.$checkedMakeBackup.' /></p>
<p class="send"><input class="autowidth" name="CMD[save]" type="submit" id="a4neditlocallang_save" value="'.$LANG->getLL('globalSave').'" /></p>
</form>';
	  return $output;
	}
		
 /**
  * save edit configuration file form
  * languagePrefix: savCon
  *
  * @return $output
  */
  function editConf() {
    global $LANG, $MCONF;
    // build file content
    $filecontent = '<?php
define(\'TYPO3_MOD_PATH\', \'../typo3conf/ext/a4n_edit_locallang/mod1/\');

$BACK_PATH         = \'../../../../typo3/\';

$MCONF[\'name\']   = \'tools_txa4neditlocallangM1\';
$MCONF[\'access\'] = \'user,group\';
$MCONF[\'script\'] = \'index.php\';
';
    $filecontent .= chr(10).'$MCONF[\'localExtensionPath\']   = \''.$this->CMD['localExtensionPath'].'\';';
    $filecontent .= chr(10).'$MCONF[\'systemExtensionPath\']  = \''.$this->CMD['systemExtensionPath'].'\';';
    $filecontent .= chr(10).'$MCONF[\'showLocalExtension\']   = \''.$this->CMD['showLocalExtension'].'\';';
    $filecontent .= chr(10).'$MCONF[\'showSystemExtension\']  = \''.$this->CMD['showSystemExtension'].'\';';
    $filecontent .= chr(10).'$MCONF[\'showExtensionKey\']     = \''.$this->CMD['showExtensionKey'].'\';';
    $filecontent .= chr(10).'$MCONF[\'showExtensionTitle\']   = \''.$this->CMD['showExtensionTitle'].'\';';
    $filecontent .= chr(10).'$MCONF[\'defaultLanguage\']      = \''.$this->CMD['defaultLanguage'].'\';';
    $filecontent .= chr(10).'$MCONF[\'translationDraft\']     = \''.$this->CMD['translationDraft'].'\';';
    $filecontent .= chr(10).'$MCONF[\'charencodings\']        = \''.$this->CMD['charencodings'].'\';';
    $filecontent .= chr(10).'$MCONF[\'charencodingsRead\']    = \''.$this->CMD['charencodingsRead'].'\';';
    $filecontent .= chr(10).'$MCONF[\'charencodingsWrite\']   = \''.$this->CMD['charencodingsWrite'].'\';';
    $filecontent .= chr(10).'$MCONF[\'charencodingsShow\']    = \''.$this->CMD['charencodingsShow'].'\';';
    $filecontent .= chr(10).'$MCONF[\'textLengthFormChange\'] = \''.$this->CMD['textLengthFormChange'].'\';';
    $filecontent .= chr(10).'$MCONF[\'backup\']               = \''.$this->CMD['backup'].'\';';
    $filecontent .= '

$MLANG[\'default\'][\'tabs_images\'][\'tab\'] = \'moduleicon.gif\';
$MLANG[\'default\'][\'ll_ref\']             = \'LLL:EXT:a4n_edit_locallang/mod1/locallang_mod.xml\';
?>';
    if($this->writeFile('conf.php', $filecontent)) {
      $output .= '<p class="ok">'.$LANG->getLL('savConOk').'</p>';
      include('conf.php');
    }
    else {
      $output .= '<p class="ko">'.$LANG->getLL('savConKo').'</p>';
    }
    return $output;
  }
		
 /**
  * write file
  *
  * @param string $filename
  * @param string $filecontent
  * @return boolean
  */
  function writeFile($filename, $filecontent) {
    if(is_writable($filename)) {
      $handle = fopen($filename, 'wb');
      fwrite($handle, $filecontent);
      fclose($handle);
      return true;
    }
    else {
      return false;
    }
  }
	
 /**
  * make backup
  *
  * @param string $filename
  * @return boolean
  */
  function makeBackup($filename) {
    if(copy($filename, $filename.'.'.date("Y-m-d_H-i-s"))) {
      return true;
    }
    else {
      return false;
    }
  }
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/a4n_edit_locallang/mod1/index.php']) {
  include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/a4n_edit_locallang/mod1/index.php']);
}

// make instance:
$SOBE = t3lib_div::makeInstance('tx_a4neditlocallang_module1');
$SOBE->init();

// include files?
reset($SOBE->include_once);	
while(list(,$INC_FILE) = each($SOBE->include_once))	{
  include_once($INC_FILE);
}

$SOBE->main();
$SOBE->printContent();
?>